function [A,colSwap] = GaussJordanReduction(A)
% GaussJordanReduction Reduced row echelon form.
%   R = GaussJordanReduction(A) produces the reduced row echelon form of A.
% Modualr addition

[m,n] = size(A);

% Loop over the entire matrix.
i = 1;
j = 1;
colSwap = [1:n];

% j is always equal to i (we focus on the diagonal terms)
while i <= m
   % Find value and index of largest element in the remainder of column j.
   if 0==mod(i,50), disp(['The routine is performing Gassian Reduction: ' int2str(i/m*100) '%']); end
   while i <= m
       [p,k] = max(A(i:m,j)); k = k+i-1;
       if p==1
           break;
       elseif p == 0
          [pp jj] = max(A(i,:));
          if pp==1 % this row is not all-zero.
              % Swap j-th and jj-th columns.
              A(:,[j jj]) = A(:,[jj j]);
              colSwap([j jj]) = colSwap([jj j]);
              break;
          elseif pp == 0 % this row is all zero, delete it
              A(i,:) = [];
              m = m-1;
          else
              error('Every element should be 1 or 0');
          end
      else
          error('Every element should be 1 or 0');
      end
   end
   if i > m, break; end
   
   % Swap i-th and k-th rows.
	A([i k],j:n) = A([k i],j:n);
		for k = [1:i-1 i+1:m]
         % modular addition
         if A(k,j) ==1
             A(k,j:n) = mod(A(k,j:n) + A(i,j:n), 2);  
         end
	end
	i = i + 1;
	j = j + 1;
end