% For each column (or row) of A, (x1,x2, .., xn), we have
% value = log( exp(x1) + exp(x2) + ... + exp(xn) )

function value = LogSumExp(A,dim,Algorithm)

if nargin <=1, dim =1;end
if nargin <=2, Algorithm ='EXACT';end

if strcmp(Algorithm, 'EXACT')
    value = log(sum(exp(A),dim));
elseif strcmp(Algorithm, 'MAX')
    value = max(A,[],dim);
elseif strcmp(Algorithm, 'APPROX_TABLE')
    value = max(A,[],dim);
end
