function LDPC = gnHsGs(needNew,LDPC)

N = LDPC.NJK(1);LDPC.N=N;
J = LDPC.NJK(2);LDPC.J=J;
K = LDPC.NJK(3);LDPC.K=K;

%It is not neccessary to generate new Hs, Gs ...
%then, try to find the old one
if 1 == strcmp(needNew,'NO')
    filenameHsGs=['HsGs',num2str(N),'_',num2str(J),'_',num2str(K),'.mat'];
	if 2 == exist(filenameHsGs)
        load(filenameHsGs,'M','Q1','Q2','Gs','bitInQ2','checkInQ1');
        LDPC.M = M;
        LDPC.Gs=Gs;
        LDPC.Q1=Q1;   %Bit-to-Check
        LDPC.Q2=Q2;   %Check-to-Bit
        LDPC.bitInQ2    = bitInQ2;
        LDPC.checkInQ1  = checkInQ1;
        return;
    end
end

if mod(N*J/K,J)~=0
    error('M should a multiple of J');
end
H = kron(ones(1,K), eye(N/K));
for i=2:J
    p = randperm(N);
    H(N/K*(i-1)+1:N/K*i,:) = H(1:N/K,p);
end

[Hs,colSwap]  = GaussJordanReduction(H);
M  = size(Hs,1);
H             = H(:,colSwap);
for col = 1:N
    pos = find(H(:,col));
    Q1(:,col) = pos;
end
for row = 1:N*J/K
    pos =find(H(row,:));
    Q2(row,:) = pos;
end

bitInQ2 = zeros(J,N);
checkInQ1 = zeros(N*J/K,K);
for bitNo=1:size(bitInQ2,2)
    for j=1:J    
        checkNo = Q1(j,bitNo);
        col   = find( Q2(checkNo,:) == bitNo);
        bitInQ2(j,bitNo) = sub2ind(size(Q2),checkNo, col);
    end
end
if sum(abs(sort(bitInQ2(:))-[1:J*N]'))>0
    error('the position should be coveraged completely in Q2');
end
for checkNo=1:size(checkInQ1,1)
    for k=1:K
        bitNo = Q2(checkNo,k);
        row   = find( Q1(:,bitNo) == checkNo);
        checkInQ1(checkNo,k) = sub2ind(size(Q1),row, bitNo);
    end
end
if sum(abs(sort(checkInQ1(:))-[1:J*N]'))>0
    error('the position should be coveraged completely in Q1');
end



P=Hs(:,M+1:N);
I=eye(N-M);
Gs = [P' I];

if ~isempty(find(mod(Gs * H',2) ~=0))
    error('Gs and H are not orthogonal');
end



filenameHsGs=['HsGs',num2str(N),'_',num2str(J),'_',num2str(K),'.mat'];
save(filenameHsGs,'J','K','M','N','H','Q1','Q2','Hs','Gs','bitInQ2','checkInQ1');

LDPC.M  = M;
LDPC.Gs = Gs;
LDPC.Q1 = Q1;
LDPC.Q2 = Q2;
LDPC.bitInQ2 = bitInQ2;
LDPC.checkInQ1 = checkInQ1;


