% Regard each Space-Time-Block input as one super-symbol. 
%      Find the likelihood for each super-symbol

function cSymLrLikelihoods = gnLikelihood(rxSignal, LDPC, CHANNEL, ModuScheme, Es, H, No)
global logInfinity;

Nt = CHANNEL.Nt; Nr = CHANNEL.Nr;
ModuSize = ModuScheme.moduSize;
T = size(rxSignal,2);

% There are totaly "numVecSymbols" many kinds of bits' vectors
numVecSymbols = ModuSize^Nt;

allRxSignal   = zeros(Nt,T,numVecSymbols);
cleanRxSignal = zeros(Nr,T,numVecSymbols);
noisyRxSignal = zeros(Nr,T,numVecSymbols);
diff          = zeros(Nr,T,numVecSymbols);

for iVecSymbols = 0: numVecSymbols - 1
    vecSymbols  = de2bi(iVecSymbols,Nt,ModuSize,'left-msb');
    vecSignal   = gnTxSignal(vecSymbols,ModuScheme,CHANNEL,Es);
    allRxSignal(:,:,iVecSymbols+1) = repmat(vecSignal,1,T);
end
cleanRxSignal = passChannel(allRxSignal, CHANNEL, H, 0); % No=0 to generate the clean channel outputs

noisyRxSignal(:) = repmat(rxSignal,1,numVecSymbols);    % Make M^Nt copies

sizeRxStBlock = Nr * size(vecSignal,2); % The size of the received ST block
diff = reshape(cleanRxSignal-noisyRxSignal, sizeRxStBlock, T, numVecSymbols);

cSymLrLikelihoods = - 1/No * sum(diff.*conj(diff),1); % sum along the first dimension.
cSymLrLikelihoods = transpose(squeeze(cSymLrLikelihoods));  % squeeze gets rid of the singlton dimension.

cSymLrLikelihoods = cSymLrLikelihoods(2:end,:)- repmat(cSymLrLikelihoods(1,:),size(cSymLrLikelihoods,1)-1,1);

