function rxSignal = passChannel(txSignal, CHANNEL, H, No)
T = size(txSignal,2);
taps = size(H,4);  % parameter for frequency selective
Nr = size(H,1);
Nt = size(H,2);

if strcmp(CHANNEL.type, 'AWGN') || strcmp(CHANNEL.type, 'SlowFading')
    if ndims(txSignal) ~= 3
        rxSignal = H * txSignal;
    else % in this case, the txSignal1 is [Nt,T,combN]
        txSignal = reshape(txSignal,Nt,[]); % put them in [Nt,T*combN]
        rxSignal = reshape(H * txSignal, Nt, T, []); % re-put them in [Nt,T,combN]
    end
else
    if ndims(txSignal) ~= 3 % When just generating the rx signal
        rxSignal=zeros(Nr,T);
        for t=1:3
            rxSignal(:,t) = H(:,:,t) * txSignal(:,t);
        end
    else % in this case, the txSignal1 is [Nt,T,combN], this is the case to generate the clean ch outputs
       
        rxSignal = zeros(Nr,size(txSignal,3),T);
        txSignal = permute(txSignal,[1 3 2]); % put them in [Nt*T, combN]
        for t=1:T
            rxSignal(:,:,t) = H(:,:,t) * txSignal(:,:,t);
        end
        rxSignal = permute(rxSignal,[1 3 2]); % Generates all possible receive signals, put it back to
                                              % [Nt, T, M^Nt] array
    end
end

if No == 0
    return;
else
    AWGN = sqrt(No/2)*( randn(size(rxSignal))+j*randn(size(rxSignal)) );    % Eb/No=EbNoR, so No/2=Eb/EbNoR/2;
end
rxSignal=rxSignal+AWGN;
