% The function is to transfer the soft information for symbol to that for bit

% KK:               how many bits are regarded as one symbol

% bitLikelihoods:   The first row is P(bit = 0)
%                   The second row is P(bit = 1)

% symLikelihoods:   The first row is P(symbol = 0)
%                   The second row is P(symbol = 1)
%                                 ...
%                   The last row is P(symbol = 2^KK-1)

function bitLikelihoods = softSymbol2Bit(KK,symLikelihoods)
% how many symbols are invovled
symLikelihoods = symLikelihoods./ repmat(sum(symLikelihoods,1),size(symLikelihoods,1),1);

symLength = size(symLikelihoods,2);
ModuSize = 2;
%This function can only deal with the binary inputs
if size(symLikelihoods,1) ~= ModuSize^KK, error('This function can only deal with the binary inputs');end;
if KK==1, bitLikelihoods = symLikelihoods; return; end;

bitLength = symLength*KK;
bitLikelihoods = zeros(ModuSize, bitLength);

% How to express the symbol in bits
symInBits = de2bi([0:ModuSize^KK-1], KK, ModuSize, 'left-msb');

for bitIndex = 0:KK-1
    % Find position where the bitIndex-th bit appears in symLikelihoods
    posBits = find(symInBits(:,bitIndex+1)==0);
    bitLikelihoods(1, bitIndex+1+[0:symLength-1]*KK) = sum(symLikelihoods(posBits,:),1);
end
bitLikelihoods(2, :) = 1-bitLikelihoods(1, :);




